<template>
    <div class="firmBuy">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">企业采购</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="searchStr" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getfirmBuyList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="sheepId" label="羊耳标号" width="180"></el-table-column>
                    <el-table-column prop="acquisitionTime" label="收购时间" width="180"></el-table-column>
                    <el-table-column prop="origin" label="来源牧场"></el-table-column>
                    <el-table-column prop="acquisitionWeight" label="收购重量(kg)"></el-table-column>
                    <el-table-column prop="acquisitionPerson" label="收购人员"></el-table-column>
                    <el-table-column prop="transportVehicles" label="运输车辆"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addFirmBuy" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="羊耳标号">
                            <el-input v-model="formData.sheepId"></el-input>
                        </el-form-item>

                        <el-form-item label="来源牧场">
                            <el-input v-model="formData.origin"></el-input>
                        </el-form-item>

                        <el-form-item label="收购日期">
                            <el-date-picker
                                v-model="formData.acquisitionTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                        <el-form-item label="收购人">
                            <el-input v-model="formData.acquisitionPerson"></el-input>
                        </el-form-item>

                        <el-form-item label="羊只重量(kg)">
                            <el-input v-model="formData.acquisitionWeight"></el-input>
                        </el-form-item>

                        <el-form-item label="车牌号">
                            <el-input v-model="formData.transportVehicles"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addFirmBuy')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqFirmBuyList,
    reqAddFirmBuy,
    reqUpdateFirmBuy,
    reqDelFirmBuy
} from "@/api/slaughterManagment.js";

const pageSize = 10;
const rules = {};

export default {
    name: "firmBuy",
    data() {
        return {
            searchStr: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                sheepId: "1008",
                origin: "xx牧场",
                acquisitionTime: this.$moment().format("YYYY-MM-DD"),
                acquisitionPerson: "王炸",
                acquisitionWeight: "51",
                transportVehicles: "浙A 1380"
            },
            rules
        };
    },
    created() {
        // 企业采购列表
        this.getfirmBuyList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddFirmBuy(this.formData)
                            .then(res => {
                                // 企业采购列表
                                this.getfirmBuyList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateFirmBuy(this.formData)
                            .then(res => {
                                // 企业采购列表
                                this.getfirmBuyList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 企业采购列表
        getfirmBuyList() {
            reqFirmBuyList({
                searchStr: this.searchStr,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        
        add() {
            this.isShow = true;
            this.isAdd = true
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false
        },
        del(row) {
            reqDelFirmBuy(row.id)
                .then(res => {
                    console.log(res);
                    // 企业采购列表
                    this.getfirmBuyList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 企业采购列表
            this.getfirmBuyList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>